#!/usr/bin/perl 


   use Fcntl ':flock'; # import LOCK_* constants
# use strict;
   use Template;

   require "../configs/s.pl";
   require "$include_dir/msg.pl";
   require "$include_dir/tools.pl";
   require "$include_dir/parse.pl";
#   require "$include_dir/se_utils.pl";
   require "../configs/permanent.pl";
   require "$include_dir/debug.pl";
   require "$include_dir/misc.pl";
   require "$include_dir/recent.pl";
   require "$include_dir/gb.pl";

   $include_path = "../templates";


&include_file ("login.pl");
&include_file ("wiki.pl");
&include_file ("file.pl");
&include_file ("field.pl");
&include_file ("sub.pl");
&include_file ("recent.pl");
&include_file ("gb.pl");
&include_file ("brd.pl");
&include_file ("misc.pl");
&include_file ("tree.pl");

$session_id = 0;
$in_error = 0;
$index = "$cpanel";
$n_fields = 0;
$field = -1;

$USER = '';

srand (time ^ $$);

&decode_vars;

if ($FORM{'user'}) {
   $USER = $FORM{'user'};
}

$pwd = $FORM{'ps'};
$page = $FORM{'page'};
$FORM{'act'} = 'editme' if (defined $FORM{'page'} && 
                            !defined $FORM{'act'} &&
                            $page ne '');
$action = $FORM{'act'};

$field_dir = "";

$cp = &get_cp();
$url = &get_url();
$p = &get_path();

$field_dir = "dir_$field";
  

if (defined $action) {
   &process_action;
   exit;
}
   &check_passwd;                # authorisation
   &run_parse;                   # parse whole branch
 
   my ($fname, $dir, $gb_name_data) = &get_index_file_n_gb ($last_hash);

   my $gb_n = ( $field < 0) ? "mng" : "user";
   my $gb_m = ( $field < 0) ? $superuser_mode : 1;
   my $gb_gb = ( $field < 0) ? "" : $gb_name_data;


   my $template = Template->new ({
        INCLUDE_PATH  => $include_path,
        RELATIVE => 1, 
        ABSOLUTE => 1,
        PRE_PROCESS => "$include_path/config",
      });

   my $vars = {
        'main_list'     => \@MAIN_LIST,
        'top_item'      => $top_item,
        'last_item'     => $last_item,
        'last_hash'     => $last_hash,
        'path'          => $p,
        'url'           => $cp,
        'SITE_IP'       => $SITE_IP,
        'index'         => $index,
        'field'         => $field,
        'sub'           => $sub,
#       'print_msg'     => $MSG{'to_print'},
        'page'          => $page,
        'left_nav'      => &get_left_nav(),

        'file_to_show'  => $tmp_file, 
        'preview_link'  => $preview_link,
        'f_type'        => $file_type,
        'strip_type'    => $strip_type,
        'tmp_suffix'    => $suff,

        'FORM'          => \%FORM,

        'USER'          => $USER,
        'U_NAME'        => $name1,
        'valid_user'    => $valid_user,
        'superuser_mode'=> $superuser_mode,

        'tree'          => &get_left_tree(),
        'gb_body'       => &get_guestbook ($index, $gb_n, $gb_gb, $gb_m),
        'controls'      => &get_control(),
        'pages'         => &get_pages(),
        'tmps_found'    => &get_tmp_confirm(),
        'access'        => &access_to_field (($field < 0), 
                                             $last_item->{'HASH'}),
                };

  print "Content-type: text/html\n\n";
  $template->process ('cp_main', $vars) || 
                      die $template->error(), "\n";


exit 0;

###########################################################################
sub get_left_tree {
###########################################################################
  my @tmp = &visit_all ("", $fields_file, "");

  return \@tmp;
}  

  
###########################################################################
sub get_guestbook {
###########################################################################
   my  ($gb_scr, $active,  $gb_gb_name, $mng_mode) = @_;
   my  $gb = &get_gb ($active, $gb_gb_name);

#   $h= debug_print_hash ($gb);
#   print $h;
#   exit;

   my $ret = &gb_show_ret ($gb, $gb_gb_name, $mng_mode, $gb_scr);

   return $ret;
}

###########################################################################
sub get_left_nav {
###########################################################################
  return undef;
}
 
###########################################################################
sub process_action {
###########################################################################
   my $is_top;

   if ($action eq 'login') {
      &disp_login_promt;
      exit 0;
   }

   &check_passwd;                # authorisation
   &run_parse;                   # parse whole branch

   $is_top = ($field < 0);

   if ($action eq 'f_add') {
      &check_access ("-1", $is_top, $last_item, "add field");
      &add_sub;      

      return;
   }

   if ($action eq 'add_user') {
      &add_user_form;      
      exit 0;
   }

   if ($action eq 'u_edit' || $action eq 'u_del') {
      &check_access ("-1", $is_top, $last_item, "edit user");
      &edit_user_form;      
      exit 0;
   }

   if ($action eq 'f_del') {
      if ($field < 0) {return;}
      &check_access ($field,  $is_top, $last_item,"delete field");
      return;
   }   

   if ($action eq 'f_del_confirm') {
      if ($field < 0) {return;}
      &check_access ($field, $is_top, $last_item, "delete field");
      &f_delete;
      return;
   }

   if ($action eq 'sort') {
      &check_access ("-1", $is_top, $last_item, "sort fields") 
                    if ($field eq '');
      &check_access ($field,  $is_top, $last_item, "sort sub-fields");
      &sort_everything;
      return;
   }

   if ($action eq 's_add') {
      if ($field < 0) {return;}
      &check_access ($field,  $is_top, $last_item,"add sub field");
      &add_sub;      
      return;
   }

   if ($action eq 'upload') {
      &check_access ($field,  $is_top, $last_item,"field upload");
      &get_file;
      return;
   }

   if ($action eq 'f_edit') {
      &check_access ($field,  $is_top, $last_item,"field edit");
      &edit_sub;
      return;
   }

   if ($action eq 's_edit') {
      &check_access ($field,  $is_top, $last_item,"sub field edit");
      &edit_sub;
      return;
   }

   if ($action eq 'brd') {
      &check_access ($field,  $is_top, $last_item, "board edit");
      $page = $FORM{'page'};
      &do_brd;
      return;
   }

   if ($action eq 'gb_dele') {
      &check_access ($field,  $is_top, $last_item, "guestbook edit");
      my $gb;

      if (!defined $FORM{'gb_id'} || $FORM{'gb_id'} eq '') {
         if ($is_top) { $gb = "mng"; } else { $gb = "user";}
      }
      else { 
         $gb = $FORM{'gb_id'};
      }

      &gb_dele($gb, $last_hash->{"GB_NAME"});

      print "Location: $cp?page=$page\n\n";
      exit 0;
   }

   if ($action eq 'gb_add') {
      my $gb;

      if (!defined $FORM{'gb_id'} || $FORM{'gb_id'} eq '') {
         if ($is_top) { $gb = "mng"; } else { $gb = "user";}
      }
      else { 
         $gb = $FORM{'gb_id'};
      }

      &gb_add ($gb, $last_hash->{"GB_NAME"});

      print "Location: $cp?page=$page\n\n";
      exit 0;
   }

   if ($action eq 'file_edit' || $action eq 'scrub') {
      &check_access ($field,  $is_top, $last_item, "edit_file_confirm");
      &edit_file_confirm;
      exit 0;
   }

   if ($action eq 'tmp_confirm') {
      &check_access ($field,  $is_top, $last_item, "edit_file_yes");
      &edit_file_yes;
      print "Location: $cp?page=$page\n\n";
      exit 0;
   }

   if ($action eq 'news_update') {
      &check_access ($field,  $is_top, $last_item, "update_file - add news");
      &update_file;
      exit 0;
   }

   if ($action eq 'go') {
      &remove_session;
      &remove_cookie ($c_pwd_name);
      print "location: http://$SITE_IP/$cpanel?act=login\n\n";
      exit 0;
   }

   if ($action eq 'editme') {
      &check_access ($field,  $is_top, $last_item, "edit_file_page");
      &edit_file_page; 
      exit 0;
   }

   if ($action eq 'add_user_a') {
      &check_access ("-1",  $is_top, $last_item, "add user");
      &add_user_act;      
      print "location: http://$SITE_IP/$cpanel?act=add_user\n\n";
      exit 0;
   }  

   if ($action eq 'u_edit_a') {
      &check_access ("-1",  $is_top, $last_item, "add user");
      &edit_user_act;      
      print "location: http://$SITE_IP/$cpanel?act=add_user\n\n";
      exit 0;
   }  

   if ($action eq 'u_del_a') {
      &check_access ("-1",  $is_top, $last_item, "add user");
      &edit_user_act;      
      print "location: http://$SITE_IP/$cpanel?act=add_user\n\n";
      exit 0;
   }  

   if ($action eq 'ch_pwd') {
      &change_pwd_act;
      &remove_session;
      &remove_cookie ($c_pwd_name);
      print "location: http://$SITE_IP/$cpanel?act=login\n\n";
      exit 0;
   }  

   &internal_actions();
   exit 0;
}

###########################################################################
sub sort_everything {
###########################################################################
my $file = '';
my $file_to = '';
my $numb = 0;
my $tt = '';
my @order = ();
my @sorted_o = ();
my $is_top = ($field == -1) ;
my %F_;
my $items;

  if ($is_top) {
     $file_to = $fields_file;
     $items = $last_item->{'UP_LIST'};
  }
  else {
     $file_to = ${$last_item->{'HASH'}}{'DESC_FILE'};
     $items = $last_item->{'DOWN_LIST'};
  }
 
  $file = "$start_path/$data_dir/$file_to";
  &error ("bad_data", "des file doesn't exists") 
         if (! -e $file || -d $file);

  # &error ("", "is_top = $is_top,  $file");

  foreach $item (@$items) {
     $key = $item->{'KEY'};
     $tt = $FORM{"f_$key"}; 
     $tt = $numb+1 if ($tt eq '' || $tt !~ /^\d+$/);

  #   &report ("key = $key order = $tt");

     push @order, $tt; 
     $val{$tt} = $key;
     $F_{$key} = $item->{'RAW_LINE'};
     $numb++;
  }

  @sorted_o = (sort { $a <=> $b } @order);
  open (DATA, ">$file") ;
  flock(DATA, LOCK_EX);

  foreach $o (@sorted_o) {
     $key = $val{$o};

     if ($key ne '' && defined $F_{$key}) {
        print DATA $F_{$key}, "\n";
#        &report ("pishem $key");
     }
  }

  flock(DATA, LOCK_UN);
  close DATA;

  &report(" sorted: $p ($file_to)");
  print "Location: $cp\n\n";
  exit;
}

###########################################################################
#sub delete_warning {
############################################################################
#   print "<div align=center><h1>$MSG{'060'}??</h1></div>\n";
#   print "<br><p>\n";
#   print "<div align=center><a href=$cp?act=f_del_confirm><font size=+5>Yes</font></a>";
#   print " or <a href=$cp><font size=+5>No</font></a></div>\n<br><p>\n";
#}

###########################################################################
sub internal_actions {
###########################################################################
  my $ret = 0;
  
  if ($action eq 'f_del') {
    &delete_warning; 
    $ret = 1;
  }
  elsif ($action eq 'showpic') {
     &show_dir ($gr_type); 
     $ret = 1;
  }
  elsif ($action eq 'showcss') {
     &show_dir ($css_type); 
     $ret = 1;
  }  
  elsif ($action eq 'tt') {
     &show_dir ($tt_type);
     $ret = 1;
  } 
  elsif ($action eq 'showstatics') {
     &show_dir ($static_type);
     $ret = 1;
  } 

  return $ret;
}


