#!/usr/local/bin/perl
{
# based on  WWWBoard  by Matt Wright (Version 2.0 ALPHA 2.1)
# see original at http://www.worldwidemart.com/scripts/   

$basedir = "$start_path/brd";
$baseurl = "$SITE_IP";
$cgi_url = "http://$SITE_IP/$front_page";

$datafile = "data.txt";
$result = "";
$ext = "ht";

$show_faq = 0;		
$allow_html = 0;
$quote_text = 1;
$subject_line = 0;
			
$use_time = 1;	

$show_poster_ip = 1; 
$enforce_max_len = 0;
%max_len = (
            'brd_name', 50, 
            'brd_email', 70, 
            'brd_where', 70, 
            'brd_subject', 80, 
            'brd_url', 150, 
            'brd_url_title', 80,
            'brd_img', 150,
            'brd_body', 3000,
            'brd_origsubject', 80,
            'brd_origname', 50,
            'brd_origemail', 70,
            'brd_origdate', 50);

 'success';
}

###########################################################################
sub do_brd {
###########################################################################
  my @result = ();

  if ($field eq '') {
     &error (bad_data, "cannot identify board\'s page - $field, $sub");
  }

  &error ("", "Incorrect path") if (!$field_dir);

  $basedir = "$field_dir_base/$field_dir";
  $mesgfile = $last_hash->{'INDEX_FILE'};
 
  if ($mesgfile eq '') { &error (bad_data, "forum file not found");}

  if ($FORM{'brd_act'} eq 'brd_add') { 
     &brd_add_record;
     @result = &brd_show;
  }
  elsif ($FORM{'brd_act'} eq 'brd_show_rec') {
     @result = &brd_show_rec;
  }
  elsif ($FORM{'brd_act'} eq 'brd_remove' && $valid_user == 1) {
     &brd_remove_act;
  }
  else {
     &error (bad_data, "no such action");
  }
  
  return @result;
}

###########################################################################
sub brd_show {
###########################################################################
   my @main = ();

   open(MAIN,"$basedir/$mesgfile") || &error (bad_data, "$! by open $mesgfile.");
   @main = <MAIN>;
   close(MAIN);

   return @main;
}

###########################################################################
sub brd_show_rec {
###########################################################################
   my @main = ();

   open(MAIN,"$basedir/$FORM{'brd_num'}\.$ext") || 
       &error (bad_data, "$!  by open $FORM{'brd_num'}\.$ext");

   @main = <MAIN>;
   close(MAIN);

   return @main;
}

###########################################################################
sub brd_add_record {
###########################################################################
  my ($name, $value);

  &get_number;

  foreach $name (keys %max_len) {
     if (length ($FORM{$name}) > $max_len{$name}) {
        &error (bad_data, "$FORM{$name} is too long."); 
     }
  }

  &get_variables; 
  &new_file;
  &main_page;

  if ($num_followups >= 1) {
     &thread_pages;
  }

#  &return_html;
  &increment_num;
}

###########################################################################
sub get_number  {
###########################################################################
   open(NUMBER,"$basedir/$datafile");
   $num = <NUMBER>;
   close(NUMBER);
   if ($num == 999999 || $num !~ /^\d+$/)  {
      $num = "1";
   }
   else {
      $num++;
   }

}

###########################################################################
sub get_variables {
###########################################################################
   if ($FORM{'brd_followup'}) {
      $followup = "1";
      @followup_num = split(/,/,$FORM{'brd_followup'});

      local(%fcheck);
      foreach $fn (@followup_num) {
         if ($fn !~ /^\d+$/ || $fcheck{$fn}) { 
            &error(bad_data, "bad followup: $fn"); 
         }
         $fcheck{$fn} = 1;
      }
      @followup_num = keys %fcheck;

      $num_followups = @followups = @followup_num;
      $last_message = pop(@followups);
      $origdate = "$FORM{'brd_origdate'}";
      $origname = "$FORM{'brd_origname'}";
      $origsubject = "$FORM{'brd_origsubject'}";
   }
   else {
      $followup = "0";
   }
   if ($FORM{'brd_name'}) {
      $name = "$FORM{'brd_name'}";
      $name =~ s/"//g;
      $name =~ s/<//g;
      $name =~ s/>//g;
      $name =~ s/\&//g;
   }
   else {
      &error(bad_data, "name is missing");
   }

   if ($FORM{'brd_email'} =~ /.*\@.*\..*/) {
      $email = "$FORM{'brd_email'}";
   }

   if ($FORM{'brd_subject'}) {
      $subject = "$FORM{'brd_subject'}";
      $subject =~ s/\&/\&amp\;/g;
      $subject =~ s/"/\&quot\;/g;
   }
   else {
      &error(bad_data, "subject is missing");
   }

   if ($FORM{'brd_where'}) {
      $where = "$FORM{'brd_where'}";
      $where =~ s/\&/\&amp\;/g;
      $where =~ s/"/\&quot\;/g;
   }

   if ($FORM{'brd_url'} =~ /.*\:.*\..*/ && $FORM{'brd_url_title'}) {
      $message_url = "$FORM{'brd_url'}";
      $message_url_title = "$FORM{'brd_url_title'}";
   }

   if ($FORM{'brd_img'} =~ /.*tp:\/\/.*\..*/) {
      $message_img = "$FORM{'brd_img'}";
   }

   if ($FORM{'brd_body'}) {
      $body = "$FORM{'brd_body'}";
      $body =~ s/\cM//g;
      $body =~ s/\n\n/<p>/g;
      $body =~ s/\n/<br>/g;
      $body =~ s/\r//g;

      $body =~ s/&lt;/</g; 
      $body =~ s/&gt;/>/g; 
      $body =~ s/&quot;/"/g;
   }
   else {
      &error(bad_data, "no body");
   }

   if ($quote_text == 1) {
      $hidden_body = "$body";
      $hidden_body =~ s/</&lt;/g;
      $hidden_body =~ s/>/&gt;/g;
      $hidden_body =~ s/"/&quot;/g;
   }

   ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);

   $month = ($mon + 1);

   @months = ("", "","","","","","","",""," ", "","");
#  @months = ("Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec");
#
   $year += 1900;
   $long_date = sprintf("%s %02d, %4d at %02d:%02d:%02d",$months[$mon],$mday,$year,$hour,$min,$sec);

   $year %= 100;
   if ($use_time == 1) {
      $date = sprintf("%02d:%02d:%02d %02d-%02d-%02d",$hour, $min, $sec, $mday, $month, $year);
   }
   else {
      $date = sprintf("%02d-%02d-%02d", $mday, $month, $year);
   }
}

###########################################################################
sub new_file {
###########################################################################
   my $w_w = "";

  if ($where) {$w_w = " from $where";}

  open(NEWFILE,">$basedir/$num\.$ext") || &error (bad_data, "$!  by open $num\.$ext");
  flock(NEWFILE, LOCK_EX);
 
  print NEWFILE "$MSG{'brd_sent'} ";
  if ($email) {
     print NEWFILE "<a href=\"mailto:$email\"><b>$name</b></a> $w_w";
  }
  else {
     print NEWFILE "<b>$name</b> $w_w\n";
  }
   
  print NEWFILE "<!-- ($hostname - $ip_address) --> "; 
  print NEWFILE " $long_date:\n<br>Subject: <b>$subject</b><p>\n";

  if ($followup == 1) {
     print NEWFILE "$MSG{'brd_r'}: <a href=\"$url?act=brd\&brd_act=brd_show_rec\&brd_num=$last_message\">$origsubject</a> $MSG{'ed_from'} ";

     if ($origemail) {
        print NEWFILE "<a href=\"$origemail\">$origname</a> $origdate:<p>\n";
     }
     else {
        print NEWFILE "<b>$origname</b> $origdate:<p>\n";
     }
  }

  if ($message_img) {
     print NEWFILE "<div align=center><img src=\"$message_img\"></div><p>\n";
  }
  print NEWFILE "$body\n";
  print NEWFILE "<br>\n";
  if ($message_url) {
     print NEWFILE "<ul><li><a href=\"$message_url\">$message_url_title</a></ul>\n";
  }
  print NEWFILE "<br><p>\n";
  print NEWFILE "<a name=\"followups\"></a><br>\n";
  print NEWFILE "<ul><!--insert: $num-->\n";
  print NEWFILE "</ul><!--end: $num-->\n";
  print NEWFILE "<br><p>\n";
  print NEWFILE "<a name=\"postfp\"></a><p>\n";

  print NEWFILE "<form method=POST action=\"$cgi_url\">\n";

#special variables for $front_page
  print NEWFILE "<input type=hidden name=\"act\" value=\"brd\">\n";
  print NEWFILE "<input type=hidden name=\"path\" value=\"/$p\">\n";
  print NEWFILE "<input type=hidden name=\"brd_act\" value=\"brd_add\">\n";

  print NEWFILE "<input type=hidden name=\"brd_followup\" value=\"";
  if ($followup == 1) {
     foreach $followup_num (@followup_num) {
        print NEWFILE "$followup_num,";
     }
  }
   print NEWFILE "$num\">\n";
   print NEWFILE "<input type=hidden name=\"brd_origname\" value=\"$name\">\n";
   if ($email) {
      print NEWFILE "<input type=hidden name=\"brd_origemail\" value=\"$email\">\n";
   }
   print NEWFILE "<input type=hidden name=\"brd_origsubject\" value=\"$subject\">\n";
   print NEWFILE "<input type=hidden name=\"brd_origdate\" value=\"$long_date\">\n";
   print NEWFILE "<hr>\n<br><table><tr>\n<td>$MSG{'gb_name'}:</td>\n<td><input type=text name=\"brd_name\" size=20></td></tr>\n";
   print NEWFILE "<tr><td>E-Mail:</td>\n<td><input type=text name=\"brd_email\" size=20></td></tr>\n";
   print NEWFILE "<tr><td>$MSG{'gb_town'}:</td>\n<td><input type=text name=\"brd_where\" size=20></td></tr></table>\n";
   if ($subject_line == 1) {
      if ($subject_line =~ /^Re:/) {
         print NEWFILE "<input type=hidden name=\"brd_subject\" value=\"$subject\">\n";
         print NEWFILE "$MSG{'brd_s'}: <b>$subject</b><p>\n";
      }
      else {
         print NEWFILE "<input type=hidden name=\"brd_subject\" value=\"Re: $subject\">\n";
         print NEWFILE "$MSG{'brd_s'}: <b>Re: $subject</b><p>\n";
      }
   } 
   elsif ($subject_line == 2) {
      print NEWFILE "$MSG{'brd_s'}: <input type=text name=\"brd_subject\" size=20><p>\n";
   }
   else {
      if ($subject =~ /^Re:/) {
         print NEWFILE "$MSG{'brd_s'}: <input type=text name=\"brd_subject\" value=\"$subject\" size=20><p>\n";
      }
      else {
         print NEWFILE ": <input type=text name=\"brd_subject\" value=\"Re: $subject\" size=20><p>\n";
      }
   }
   print NEWFILE "$MSG{'brd_c'}:<br>\n";
   print NEWFILE "<textarea name=\"brd_body\" COLS=50 ROWS=10>\n";
   if ($quote_text == 1) {
      @chunks_of_body = split(/\&lt\;p\&gt\;/,$hidden_body);
      foreach $chunk_of_body (@chunks_of_body) {
         @lines_of_body = split(/\&lt\;br\&gt\;/,$chunk_of_body);
         foreach $line_of_body (@lines_of_body) {
            print NEWFILE "\> $line_of_body\n";
         }
         print NEWFILE "\n";
      }
   }
   print NEWFILE "</textarea>\n";
   print NEWFILE "<p>\n";
   print NEWFILE "<input type=submit value=\"$MSG{'brd_rr'}\"> <input type=reset>\n";
   print NEWFILE "<p>\n";

   flock(NEWFILE, LOCK_UN);
   close(NEWFILE);

# ### send e-mail
  $to_addr = $def_to_addr;
  $to_addr =  $last_hash->{'EMAIL'} if ($last_hash->{'EMAIL'}) ;

      open (TF, "$email_command") || return;
      print TF "To: $to_addr\n";
      print TF "From: $from_addr\n";
      print TF "Subject: Board RECORD!\n\n";  

      print TF <<END;
message_url=$url?act=brd\&brd_act=brd_show_rec\&brd_num=$num
name=$name
email=$email
location=$where
subject=$subject
file=$field_dir/$num\.$ext
addr=$ip_address
host=$hostname
date=$date
END

      print TF "\n\n---------------------->>>>>\n";
      print TF $FORM{'brd_body'};
      close TF;
      &report ("forum $field_dir/$mesgfile updated - mail sent to $to_addr.");
      &recent_changed;

# ### end of email.

}


###########################################################################
sub main_page {
###########################################################################
   my @main = ();

   open(MAIN,"$basedir/$mesgfile") || &error (bad_data, "$! by open $mesgfile");
   @main = <MAIN>;
   close(MAIN);

   open(MAIN,">$basedir/$mesgfile") || &error (bad_data, "$! by open $mesgfile");
   flock(MAIN, LOCK_EX);

   if ($followup == 0) {
      foreach $main_line (@main) {
         if ($main_line =~ /<!--begin-->/) {
            print MAIN "<!--begin-->\n";
	    print MAIN "<!--top: $num--><li><a href=\"$url?act=brd\&brd_act=brd_show_rec\&brd_num=$num\">$subject</a> - <b>$name</b> <i>$date</i>\n";
            print MAIN "(<!--responses: $num-->0)\n";
            print MAIN "<ul><!--insert: $num-->\n";
            print MAIN "</ul><!--end: $num-->\n";
         }
         else {
            print MAIN "$main_line";
         }
      }
   }
   else {
      foreach $main_line (@main) {
	 $work = 0;
         if ($main_line =~ /<ul><!--insert: $last_message-->/) {
            print MAIN "<ul><!--insert: $last_message-->\n";
            print MAIN "<!--top: $num--><li><a href=\"$url?act=brd\&brd_act=brd_show_rec\&brd_num=$num\">$subject</a> - <b>$name</b> <i>$date</i>\n";
            print MAIN "(<!--responses: $num-->0)\n";
            print MAIN "<ul><!--insert: $num-->\n";
            print MAIN "</ul><!--end: $num-->\n";
         }
         elsif ($main_line =~ /\(<!--responses: (.*)-->(.*)\)/) {
            $response_num = $1;
            $num_responses = $2;
            $num_responses++;
            foreach $followup_num (@followup_num) {
               if ($followup_num == $response_num) {
                  print MAIN "(<!--responses: $followup_num-->$num_responses)\n";
		  $work = 1;
               }
            }
            if ($work != 1) {
               print MAIN "$main_line";
            }
         }
         else {
            print MAIN "$main_line";
         }
      }
   }
   flock(MAIN, LOCK_UN);
   close(MAIN);
}

###########################################################################
sub thread_pages {
###########################################################################
  my $url=&get_url;

   foreach $followup_num (@followup_num) {
      open(FOLLOWUP,"$basedir/$followup_num\.$ext");
      @followup_lines = <FOLLOWUP>;
      close(FOLLOWUP);

      open(FOLLOWUP,">$basedir/$followup_num\.$ext");
      flock(FOLLOWUP, LOCK_EX);

      foreach $followup_line (@followup_lines) {
         $work = 0;
         if ($followup_line =~ /<ul><!--insert: $last_message-->/) {
	    print FOLLOWUP "<ul><!--insert: $last_message-->\n";
            print FOLLOWUP "<!--top: $num--><li><a href=\"$url?act=brd\&brd_act=brd_show_rec\&brd_num=$num\">$subject</a> <b>$name</b> <i>$date</i>\n";
            print FOLLOWUP "(<!--responses: $num-->0)\n";
            print FOLLOWUP "<ul><!--insert: $num-->\n";
            print FOLLOWUP "</ul><!--end: $num-->\n";
         }
         elsif ($followup_line =~ /\(<!--responses: (.*)-->(.*)\)/) {
            $response_num = $1;
            $num_responses = $2;
            $num_responses++;
            foreach $followup_num (@followup_num) {
               if ($followup_num == $response_num) {
                  print FOLLOWUP "(<!--responses: $followup_num-->$num_responses)\n";
                  $work = 1;
               }
            }
            if ($work != 1) {
               print FOLLOWUP "$followup_line";
            }
         }
         else {
            print FOLLOWUP "$followup_line";
         }
      }
      flock(FOLLOWUP, LOCK_UN);
      close(FOLLOWUP);
   }
}

###########################################################################
sub increment_num {
###########################################################################
   open(NUM,">$basedir/$datafile") || &error (bad_data, "$! by store message.");
   flock(NUM, LOCK_EX);
   print NUM "$num";
   flock(NUM, LOCK_UN);
   close(NUM);
}

###########################################################################
sub brd_remove_act {
###########################################################################
# some code from :
# WWWBoard Admin                Version 2.0 ALPHA 2.1                 
# Copyright 1996 Matt Wright    mattw@worldwidemart.com              
#
  for ($i = $FORM{'abrd_min'}; $i <= $FORM{'abrd_max'}; $i++) {
      if ($FORM{$i} eq 'all') {
         push(@ALL,$i);
      }
      elsif ($FORM{$i} eq 'single') {
         push(@SINGLE,$i);
      }
   }

   open(MSGS,"$basedir/$mesgfile")|| &error (bad_data, "$! by open $mesgfile");
   @lines = <MSGS>;
   close(MSGS);

   foreach $single (@SINGLE) {
      foreach ($j = 0;$j <= @lines;$j++) {
         if ($lines[$j] =~ /<!--top: $single-->/) {
            splice(@lines, $j, 3);
            $j -= 3;
         }
         elsif ($lines[$j] =~ /<!--end: $single-->/) {
            splice(@lines, $j, 1);
            $j--;
         }
      }

      &report ("removing $single out from $field_dir/$mesgfile");

      $filename = "$basedir/$mesgdir/$single\.$ext";
      if (-e $filename) {
         unlink("$filename") || &error (bad_data, "cannot remove $single");
      }
   }

   foreach $all (@ALL) {
      undef($top); undef($bottom);
      foreach ($j = 0;$j <= @lines;$j++) {
         if ($lines[$j] =~ /<!--top: $all-->/) {
            $top = $j;
         }
         elsif ($lines[$j] =~ /<!--end: $all-->/) {
            $bottom = $j;
         }
      }
      if ($top && $bottom) {
         $diff = ($bottom - $top);
         $diff++;
         for ($k = $top;$k <= $bottom;$k++) {
            if ($lines[$k] =~ /<!--top: (.*)-->/) {
               push(@DELETE,$1);
            }
         }
         splice(@lines, $top, $diff);
         foreach $delete (@DELETE) {
            $filename = "$basedir/$mesgdir/$delete\.$ext";
            &report ("== removing $delete out from forum $field_dir/$mesgfile");
            if (-e $filename) {
               unlink($filename) || push(@NOT_REMOVED,$delete);
            }
         }
      }
   }

   open(WWWBOARD,">$basedir/$mesgfile")|| &error (bad_data, "$! by open $mesgfile");
flock(WWWBOARD, LOCK_EX);
   print WWWBOARD @lines;
flock(WWWBOARD, LOCK_UN);
   close(WWWBOARD);      

   print "Location: $cp?page=$page\n\n";
   exit 0;
}
