#!/usr/local/bin/perl 

{

'success';

}    

###########################################################################
sub access_to_field {
###########################################################################
 my ($is_top, $hash) = @_;
 my $item;

 if ($superuser_mode > 0) {
    return 1;
 }

 if ($is_top) {
    return 0;
 }

 if (!$hash) {    
    return 0;
 }

 if (!defined $hash->{'USERS'} || 
     !($hash->{'USERS'}) ||
     $hash->{'USERS'} eq '') {
    return 0;
 }

 my @users = split(/\,/, $hash->{'USERS'});

 foreach $item (@users) {
   if ($item =~ /$USER/si) {
      return 1;
   }
 } 

 return 0;
}

###########################################################################
sub check_access {
###########################################################################
  my ($level, $is_top, $item, $text) = @_;
  my $ok = '';

  if ($superuser_mode > 0) {return;}

  if ($level == -1) {
     if ($superuser_mode < 1) {
        &error (bad_data, " Access violation : $text");
     }

     return;
  }

  while (defined $item && defined $item->{'HASH'}) {
     $ok = &access_to_field ($is_top, $item->{'HASH'});
     if ($ok > 0)  {return;}
     $item  = $item->{'UP_ITEM'};
  }

  &error (bad_data, " Access violation : $text ($p)");
}

###########################################################################
sub error {
###########################################################################

   if ($in_error > 0) {return 0;}

   $in_error = 1;
   $error = $_[0];
   $msg = $_[1];
   $msg1 = '';

   if ($error eq 'bad_data') {
      $msg1 = "$MSG{'Error'} : ";
   }

   if ($error eq 'file_not_found') {
      $msg1 = "$MSG{'Err_file'} : ";
   }

   my $template = Template->new ({
        INCLUDE_PATH  => $include_path,
        RELATIVE => 1, 
        ABSOLUTE => 1,
        PRE_PROCESS => "$include_path/config",
      });

   my $vars = {
        'msg1'  => $msg1,
        'msg2'  => $msg,
        'mail'  => $def_to_addr,
               };

   print "Content-type: text/html\n\n";
   &report_err ("$msg1.$msg");
   $template->process ('error', $vars) || die $template->error(), "\n";

   exit 0;
}

###########################################################################
sub show_action_log {
###########################################################################
   my $count = 0;
   my @fin_log = ();
   my $item = '';

   if ($show_act_log < 1) {return;}
   if ($logfile eq '') {return;}

   if (-e $logfile) {
      open (LOG,$logfile);
      my @log = <LOG>;
      close LOG;

      print "\n Log file: <pre>";

      $item = pop @log;
      while ($count < $show_act_log_count && $item) {
         push @fin_log, $item;
         $count++;
         $item = pop @log;
      }

      $item = pop @fin_log;
      while ($item) {
         print $item;
         $item = pop @fin_log;
      }

     print "</pre><br>\n";
   }
}

###########################################################################
sub report_auth {
###########################################################################
  my $text = '';
  my $comment = $_[0];
  
  $text = "user \"$USER\" $comment";

  &write_log ($auth_log, $text);
}

###########################################################################
sub report_err {
###########################################################################
  my $text = '';
  my $comment = $_[0];
  
  $text = "user \"$USER\" \"$session_id\" $comment";

  &write_log ($err_log, $text);
}

###########################################################################
sub report_user {
###########################################################################
  my $text = '';
  my $comment = $_[0];

#  $text =  "$ENV{'REQUEST_URI'} $comment";
  $text =  "path='$p' $comment";
  &write_log ($user_log, $text);
}

###########################################################################
sub report {
###########################################################################
  my $text;
  $text = $_[0];

  &write_log ($logfile, $text);
}

###########################################################################
sub write_log {
###########################################################################
  my ($text, $file);
     
  $text = $_[1];
  $file = $_[0];

  if ($logfile eq '') {return};

  open (LOG,">>$file") || &error ("", "cannot write log $file : $!");
  if ($hostname ne '') {
     print LOG " $hostname : $date: ";
  }
  else {
     print LOG " $ip_address : $date: ";
  }
  
  print LOG "$text\n";
  close (LOG);
}


###########################################################################
sub decode_vars {
###########################################################################

my ($k, $key, $c, $content);
my ($item, $foo);
my @pairs = ();
my $bound;


# $path = '';
$all_input = '';

  read (STDIN, $all_input, $ENV{'CONTENT_LENGTH'}) if (defined $ENV{'CONTENT_LENGTH'});

  if ($ENV{'QUERY_STRING'}) {
     $all_input = "$all_input\&$ENV{'QUERY_STRING'}";
  }

  @pairs=split(/&/,$all_input);

  foreach $item(@pairs)
  {
    ($key,$content)=split(/=/,$item,2);

    if (defined $content) {
       $content=~tr/+/ /;
       $content=~s/%(..)/pack("c",hex($1))/ge;

        # preserve binary files.
       if ($key ne 'file_data' && 
           $key ne 'gb_data' && 
           $key ne 'file' && 
           $key ne 'brd_body' &&
           $key ne 'userfile') {
          $content=~s/\012//gs;
          $content=~s/\015/ /gs;
          $content=~s/&gt\;//gs;
          $content=~s/&lt\;//gs;
          $content=~s/&quot\;//gs;
       }
   
       if ($key eq 'brd_body' || $key eq 'gb_data') {
          $content=~s/&gt\;//gs;
          $content=~s/&lt\;//gs;
          $content=~s/&quot\;//gs;
       }
   
       $FORM{$key}=$content;
    }
  }

  @pairs = ();

  if (defined $FORM{'act'} && $FORM{'act'} eq 'upload') {
     $all_input =~ /^(.+)\r\n/;
     $bound = $1;
     @pairs = split(/$bound/, $all_input);

     foreach $item(@pairs)
     {
        $content = '';

        if ($item ne '') {
           my ($k, $key, $c, $content, $lost) = split(/\r\n/,$item);
           my ($k, $it, $foo) = split(/\;/,$key);

           $it =~ s/\"//gs;
           my ($k, $key) = split(/=/,$it);
           
           if ($c =~ /Content-Type:/) {
             $content = $item;
             $content =~ s/^\r\n.+filename.+[^\w\.\%-]([\w\.\%-]+)"\r\n(.*\r\n)\r\n//;
             $content =~ s/\r\n$//;
           }

           if ($key ne '' && $content ne '') {
              $FORM{$key}=$content;
           }

           # filename
           
           $foo =~ s/\"//gs;
           my ($k1, $key1) = split(/=/,$foo);
           if ($foo ne '' && $k1 ne '') {
              $k1 =~ s/ //gs;
              $FORM{$k1}=$key1;
           }
         }
     }
  }

  &init_path;
  &get_user_data_statics ();
}

###########################################################################
sub init_path () {
###########################################################################
  my $pa;

  $pa = $FORM{'path'};

  if ($pa eq '') {
     $pa = $ENV{'PATH_INFO'};
     # $path = $FORM{'path'};
  }

  if ($pa eq '' && $FORM{'number'} ne '') {
     $pa = "/$FORM{'number'}";
  }

  if (defined $FORM{'number'}  && defined $FORM{'sub'}) {
     $pa = "/$FORM{'number'}/$FORM{'sub'}";
  }

  @path = &fix_path($pa);
  $path_length = scalar @path;
}

###########################################################################
sub fix_path () {
###########################################################################
  my $pa = shift;
  my $pp;
  my @pa1;
  my $f = 0;

  $pa =~ s/\/\//\//gsi;
  $pa =~ s/\/\//\//gsi;

  @pa1 = split(/\//,$pa);
  my @path = ();

  foreach $pp (@pa1) {
    if ($pp ne '' && $pp ne '/') {
       push @path, $pp;
    }
  }

  return @path;
}
 
###########################################################################
sub get_user_data_statics () {
###########################################################################
  $ip_address = "unknown";
  $ip_number = "unknown";
  $hostname = "unknown host";

  if (defined $ENV{'REMOTE_ADDR'}) {
     $ip_address = $ENV{'REMOTE_ADDR'};
     my @numbers = split(/\./, $ip_address);
     $ip_number = pack("C4", @numbers);
     $hostname = (gethostbyaddr($ip_number, 2))[0];
  }
  else {
     $hostname  = "unknown host";
  }

  $date = &sys_date;
}

###########################################################################
sub cookie_scrub() {
###########################################################################
  my($retval) = @_;

  $retval=~s/\;//;
  $retval=~s/\=//;
  return $retval;
}

###########################################################################
sub set_cookie() {
###########################################################################

  $path="/";
  my ($name,$value,$expires) = @_;
  $name=&cookie_scrub($name);
  $value=&cookie_scrub($value);

  $expires=$expires * 3600;
  $expires=int($expires);

  my $expire_at=&cookie_date($expires);
  my $namevalue="$name=$value";

  my $COOKIE="";

  if ($expires != 0) {
     $COOKIE= "Set-Cookie: $namevalue; path=$path; expires=$expire_at; ";
  }
  else {
     $COOKIE= "Set-Cookie: $namevalue; ";   #current session cookie if 0
  }

  print "$COOKIE\n";
}
###########################################################################
sub remove_cookie() {
###########################################################################

  my ($name) = @_;

  $name=&cookie_scrub($name);
  my $value="";
  my $cookie="";
  my $expires=&cookie_date(-86400);
  my $namevalue="$name=$value";

  my $COOKIE= "Set-Cookie: $namevalue; expires=$expires; ";
  print "$COOKIE\n";

  return $COOKIE;
}

###########################################################################
sub get_cookie() {
###########################################################################

  my ($name) = @_;
  my @pairs = ();

  $name=&cookie_scrub($name);
  my $temp=$ENV{'HTTP_COOKIE'};
  @pairs= split(/\; /,$temp);
  foreach my $sets (@pairs) {
    my ($key,$value)=split(/=/,$sets);
    $clist{$key} = $value;
  }
  if ($clist{$name} eq "") {$clist{$name}="0";}
  my $retval=$clist{$name};

  return $retval;
}

###########################################################################
sub cookie_date() {
###########################################################################
  my ($seconds) = @_;

  my %mn = ('Jan','01', 'Feb','02', 'Mar','03', 'Apr','04',
            'May','05', 'Jun','06', 'Jul','07', 'Aug','08',
            'Sep','09', 'Oct','10', 'Nov','11', 'Dec','12' );
  my $sydate=gmtime(time+$seconds);
  my ($day, $month, $num, $time, $year) = split(/\s+/,$sydate);
  my    $zl=length($num);
  if ($zl == 1) {
    $num = "0$num";
  }
  my $retdate="$day $num-$month-$year $time GMT";
  return $retdate;
}

###########################################################################
sub sys_date{
###########################################################################
 my %mn = ('Jan','01', 'Feb','02', 'Mar','03', 'Apr','04',
        'May','05', 'Jun','06', 'Jul','07', 'Aug','08',
        'Sep','09', 'Oct','10', 'Nov','11', 'Dec','12' );
 my $sydate=localtime(time);
 my ($day, $month, $num, $time, $year) = split(/\s+/,$sydate);
 my $zl=length($num);
    if ($zl == 1) { $num = "0$num";}
# my $retval="$year\-$mn{$month}\-$num\t$time";
 my $retval= "$day $num-$month-$year $time";
 return $retval;
}


###########################################################################
sub include_file () {
###########################################################################
  my $file = $_[0];

  if ($debug == 1) {
     require "$file";
  }
  else {
     require "$include_dir/$file";
  }
}

###########################################################################
sub get_file_date {
###########################################################################
  my $file = shift;
  my $retval = "";
  my @ret;

  my %mn = ('Jan','01', 'Feb','02', 'Mar','03', 'Apr','04',
        'May','05', 'Jun','06', 'Jul','07', 'Aug','08',
        'Sep','09', 'Oct','10', 'Nov','11', 'Dec','12' );

  if ($file ne '' && -e $file) {
     my ($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,
      $atime,$mtime,$ctime,$blksize,$blocks) = stat ($file);

     my $rest = (time - $ctime) / ( 3600 * 24 );
     my ($day, $month, $num, $time, $year) = split(/\s+/, gmtime ($ctime));
     my $zl = length($num);
     
     $num = "0$num" if ($zl == 1);

     $retval = "$num-$month-$year";
     push @ret, $retval;
     push @ret, $rest;
     push @ret, $time;
  } 
  
  return @ret;
}

