{
    $suff = ".$$";

###########################################################################
sub edit_file_yes {
###########################################################################
  my $file_type = $FORM{'f_type'};
  my ($filename, $dir, $strip_type) = &get_file_from_type ($file_type);
  my $tmp_data = &get_tmp_data ($filename, $dir, 
                                $strip_type, $FORM{'tmp_name'});
 
  my $tmp_file = $tmp_data->{'full_name'};
  my $real_name = "$dir/$filename";

  &error ("", "temporary file $file_name => $FORM{'tmp_name'} absent") 
                                                   if (! -e $tmp_file);
  if ($valid_user < 1) {
     if ($last_hash->{'WIKI'} ne 'wiki') { 
        &error (bad_data, "wiki: access violation");
     }
  }

  open (F, $tmp_file) || &error (bad_data, $!);
  my @f_data = <F>;
  close F;

# point with no return
# erase all tmp files present

  my  @old_f = ();
  my  $item1 = '';
  my  $mask = $filename;

  $mask .= "." if ($strip_type ne $gr_type);

  if ($mask ne '') {

     &report ("clean tmp files with mask \"$mask\"");

     opendir (DIR, $tmp_data->{'tmp_dir'});
     @old_f = grep {/$mask/ && -f "$tmp_data->{'tmp_dir'}/$_" } readdir(DIR);
     closedir DIR;
    
     foreach $item1 (@old_f) {
        if ($item1 ne '') {
           unlink "$tmp_data->{'tmp_dir'}/$item1"; 
           &report ("removed temp file $item1 ($p)");
        }
     }
  }

  open (F, ">$real_name") || &error (bad_data, "$! ,$real_name ");
  flock(F, LOCK_EX);
  binmode F; 

  print F @f_data;

  flock(F, LOCK_UN);
  close F;

  if ($wiki_work > 0) {
    &report ("updated file $filename ($p) by wiki");
  } else {
    &report ("updated file $filename ($p)");
  }

  &recent_changed;
}

###########################################################################
sub edit_file_confirm {
###########################################################################
  my $file_type = $FORM{'f_type'};
  my ($filename, $dir, $strip_type) = &get_file_from_type ($file_type);

  if ($action=~/scrub/i) {
     &scrub_it ($filename, $dir, $strip_type, 'file_data');
  }

  my $tmp_data = &mktmpfile ($filename, $dir, $file_type, 
                             $strip_type, 'file_data');

  &report ("updated temp file \"$tmp_data->{'tmp_name'}\" ");
  &show_editor ($tmp_data->{'full_name'}, $tmp_data->{'link'}, 
                $file_type, $strip_type);

  exit 0;
}


###########################################################################
sub get_tmp_data {
###########################################################################
  my ($file_name , $dir_name,  $strip_type, $tmp) = @_;
  my $res = undef;

  $tmp = $suff if (!defined $tmp || $tmp eq '');

  if ($strip_type eq $html_type) {
     $link = "$url?page=$page\&act=tmp_view\&tmp_name=$tmp";
     $file_name = "$file_name.$tmp";
     $dir = "$field_dir_base/$dir_name";
     $f_n = "$field_dir_base/$dir_name/$file_name";
  }
  elsif ($strip_type eq $css_type) {
     $link = "javascript:alert('Cannot preview')";
     $file_name = "$file_name.$tmp";
     $dir = $tmp_dir;
     $f_n = "$dir/$file_name";
  }
  else {
     $dir = $tmp_dir;

     if ($strip_type ne $gr_type) {
        $file_name .= ".$tmp";
     }

     $f_n = "$dir/$file_name";
     $link = "$tmp_url/$file_name";
  }

  $res = {
     'link'             => $link,
     'full_name'        => $f_n,
     'tmp_dir'          => $dir,
     'tmp_name'         => $file_name,
  };

  return $res;
}
 
###########################################################################
sub mktmpfile {
###########################################################################
  my ($file_name , $dir_name,  $file_type, $strip_type, $form_key) = @_;
  my $tmp_data = &get_tmp_data ($file_name, $dir_name, $strip_type, $suff);
  my $f_n = $tmp_data->{'full_name'};

  open (F, ">$f_n") || &error (bad_data, "Cannot create tmp file: $!");

  binmode F;                  
  flock(F, LOCK_EX);

  print F $FORM{$form_key};

  flock(F, LOCK_UN);
  close F;
  &report ("temporary $tmp_data->{'tmp_name'} created.");
 
  return $tmp_data;
}

###########################################################################
sub scrub_it {
###########################################################################
  my ($file_name , $dir_name,  $strip_type, $form_key) = @_;
  my $tmp = undef;
  my $scr = "$scrub_dir/scrub.pl";
  my $enc = "$scrub_dir/cyrcode.pl win koi8";
  my $f_n;

  $tmp = $FORM{'tmp_name'} if (defined $FORM{'tmp_name'} && 
                               $FORM{'tmp_name'} ne '');

  if (defined $tmp) {
     my $tmp_data = &get_tmp_data ($file_name, $dir_name, $strip_type, $tmp);
     $f_n = $tmp_data->{'full_name'};
  } 
  else {
     $f_n = "$dir_name/$file_name";
  }

  if (! -e $f_n) { 
     &report (" *** cannot found  $file_name for scrub");
     return;
  }

  $FORM{$form_key} = `/bin/cat $f_n | $scr | $enc`;
  &report ("scrub $file_name");
}
 

###########################################################################
sub check_wiki {
###########################################################################
   if ($field eq '' || $p eq '') {
      &error (bad_data, "wiki: cannot identify page - $field, $sub");
   }

  ($mesgfile, $basedir, $gb_name_data) = &get_index_file_n_gb ($last_hash);
  $basedir = $field_dir;

  if ($valid_user < 1) {
     if ($last_hash->{'WIKI'} ne 'wiki') { 
        &error (bad_data, "wiki: access violation");
     }
  }

  if ($mesgfile eq '') { 
     &error (bad_data, "wiki: page file not found");
  }
}


###########################################################################
sub get_tmp_confirm {
###########################################################################
  my $file_type = $FORM{'f_type'};
  my ($filename, $fdir, $strip_type) = &get_file_from_type ($file_type);
 
  my ($item1, @old_f, @tmp);
  my (@fl, @fls, $fn, $fn_s);
  my ($dir, $gb_name_data);

  my $tt = 0;
  my $mask = "$filename.";

  if ($valid_user != 1) { &error (bad_data, "access violation"); }

  return undef if ($wiki_work);
  return undef if ($file_name eq '');
  return undef if ($fdir eq '');
  return undef if ($field < 0);
#  return undef if (! defined $file_type)

  if ($strip_type eq $html_type) {
     $dir = $fdir;
  }
  else  {
     $dir = "$start_path/tmp";
  }

  opendir (DIR, $dir);
  @old_f = grep {/$mask/ && -f "$dir/$_" } readdir(DIR);
  closedir DIR;
 
  foreach $item1 (@old_f) {
     if ($item1 ne '') {
        @tmp = split (/\./, $item1);
        $fn = pop @tmp;
        push @fl, $fn;

        my @stat = &get_file_date ("$dir/$item1");
        $fn_s = $fn."  [$stat[0] $stat[2]]" if (defined $stat[0]);
        push @fls, $fn_s;
     }
  }
 
  my $ii;
  my $it;
  my @res_l = undef;

  for ($ii=0; $ii<$#fls;$ii++) {
    $item1 = $fls[$ii];
    $it = $fl[$ii];

    if ($strip_type eq $html_type) {
       $pl = "$url?page=$page\&act=tmp_view\&tmp_name=.$item1";

       $app_l = "$cp?page=$page\&act=tmp_confirm\&tmp_name=.$item1";
       $app_l .= "\&f_type=HTML\&file_dir=$field_dir";
       $app_l .= "\&file_name=$file_name";

       $el = "$cp?page=$page\&act=editme\&f_type=HTML";
       $el .= "\&tmp_name=.$it";
    }
    elsif ($strip_type eq $css_type) {
       $pl = "javascript:alert(\'Cannot preview\');";

       $app_l = "$cp?file_name=$orig_name\&act=tmp_confirm";
       $app_l .= "\&tmp_name=.$it\&f_type=$file_type";

       $el = "javascript:alert(\'not ready yet\');";
    }
    else {
       $pl = "http://$SITE_IP/tmp/$file_name";

       $app_l = "$cp?file_name=$orig_name\&act=tmp_confirm";
       $app_l .= "\&tmp_name=.$it\&f_type=$file_type";

       $el = "javascript:alert(\'not ready yet\');";
    }

    my $res = { 
    'preview_link'      => $pl, 
    'previw_text'       => $item1,
    'apply_link'        => $app_l,
    'edit'              => $el,
    };

    push @res_l, $res;
  }

  return \@res_l;
}

'success';
}


